<?php

$widgetID = $args['widget_id'];
$widgetID = str_replace('dd_last_viewed-', '', $widgetID);
$widgetOptions = get_option($this->option_name);
$thisWidget = $widgetOptions[$widgetID];
$lastviewedTitle = $thisWidget['lastviewedTitle'];
$lastViewed_total = $thisWidget['lastViewed_total'] ? $thisWidget['lastViewed_total'] : -1;
$lastViewed_truncate = $thisWidget['lastViewed_truncate'] ? $thisWidget['lastViewed_truncate'] : false;
$lastViewed_linkname = $thisWidget['lastViewed_linkname'];
$lastViewed_showPostTitle = $thisWidget['lastViewed_showPostTitle'];
$lastViewed_showThumb = $thisWidget['lastViewed_showThumb'];
$lastViewed_thumbSize = $thisWidget['lastViewed_thumbSize'];
$lastViewed_showExcerpt = $thisWidget['lastViewed_showExcerpt'];
$lastViewed_content_type = $thisWidget['lastViewed_content_type'];
$lastViewed_showTruncate = $thisWidget['lastViewed_showTruncate'];
$lastViewed_showMore = $thisWidget['lastViewed_showMore'];

$lastViewed_lv_link_title = $thisWidget['lastViewed_lv_link_title'];
$lastViewed_lv_link_thumb = $thisWidget['lastViewed_lv_link_thumb'];
$lastViewed_lv_link_excerpt = $thisWidget['lastViewed_lv_link_excerpt'];
$cookie_name = 'cookie_data_lastviewed_widget_' . $widgetID;
$lastlist = ($_COOKIE[$cookie_name]);
$idList = explode(",", $lastlist);
$idList = array_reverse($idList);
$idList = is_singular() ? array_diff($idList, array(get_the_ID())) : $idList; // strip this id from idlist if on single

extract($args, EXTR_SKIP);

$list_args = array(
    'post__in' => $idList,
    'post_type' => 'any',
    'post_status' => 'publish',
    'orderby' => 'post__in',
    'posts_per_page' => $lastViewed_total
);

$list_query = new WP_Query($list_args);
$hasThumb = $lastViewed_showThumb ? $lastViewed_showThumb : false;

if (isset($lastlist)) :

    echo $before_widget;

    if ($lastviewedTitle) {
        echo $before_title . $lastviewedTitle . $after_title;
    }

    if (!$lastViewed_showPostTitle && !$lastViewed_showExcerpt && !$hasThumb): ?>
        <p>No options set yet! Set the options in the <a
                href="<?php echo esc_url(home_url('/wp-admin/widgets.php')); ?>">widget</a>.</p>';
    <?php endif; ?>
    <ul class="lastViewedList">

        <?php while ($list_query->have_posts()) : $list_query->the_post();

            $id = get_the_ID();
            $title = get_the_title();
            $strip_content = $lastViewed_content_type == 'plain content'; // 1/0
            $regex = '/\[dd_lastviewed(.*?)\]/'; //avoid shortcode '[lastviewed] in order to prevent a loop
            $content = preg_replace($regex, '', get_the_content());
            $content = apply_filters('the_content', $content);
            $content = $strip_content ? strip_shortcodes($content) : $content;
            $content = $strip_content ? wp_strip_all_tags($content, true) : $content;
            $content = $lastViewed_content_type === 'excerpt' ? get_the_excerpt() : $content;
            $content = $lastViewed_showTruncate ? substr($content, 0, strrpos(substr($content, 0, $lastViewed_truncate), ' ')) : $content;
            $thumb = get_the_post_thumbnail($id, $lastViewed_thumbSize);
            $hasThumb = $lastViewed_showThumb && has_post_thumbnail() ? $lastViewed_showThumb : false;
            $perma = get_permalink();
            $class = $hasThumb ? "lastViewedItem clearfix" : "lastViewedItem";

            ?>
            <li class="<?php echo $class; ?>">
                <?php if ($hasThumb && !$lastViewed_lv_link_thumb): ?>
                    <div class="lastViewedThumb"><?php echo $thumb; ?></div>
                <?php elseif ($hasThumb && $lastViewed_lv_link_thumb) : ?>
                    <a class="lastViewedThumb" href="<?php echo $perma; ?>"><?php echo $thumb; ?></a>
                <?php endif; ?>

                <div class="lastViewedcontent">
                    <?php if ($lastViewed_showPostTitle && $lastViewed_lv_link_title) : ?>
                        <a class="lastViewedTitle" href="<?php echo $perma; ?>"><?php echo $title; ?></a>
                    <?php elseif ($lastViewed_showPostTitle && !$lastViewed_lv_link_title) : ?>
                        <h3 class="lastViewedTitle"><?php echo $title; ?></h3>
                    <?php endif; ?>

                    <?php if ($lastViewed_lv_link_excerpt && $lastViewed_showExcerpt) : ?>
                        <a href="<?php echo $perma; ?>" class="lastViewedExcerpt">
                            <div>
                                <?php echo $content; ?>
                                <?php if ($lastViewed_showMore) : ?>
                                    <span class="more"><?php echo $lastViewed_linkname; ?></span>
                                <?php endif; ?>
                            </div>
                        </a>
                    <?php elseif (!$lastViewed_lv_link_excerpt && $lastViewed_showExcerpt) : ?>
                        <div class='lastViewedExcerpt'>
                            <?php echo $content; ?>
                            <?php if ($lastViewed_showMore) : ?>
                                <a href="<?php echo $perma; ?>"
                                   class="more"><?php echo $lastViewed_linkname; ?></a>
                            <?php endif; ?>
                        </div>
                    <?php endif; ?>
                </div>
            </li>
        <?php endwhile; ?>
    </ul>
    <?php echo $after_widget; ?>
<?php endif; ?>
<?php wp_reset_query();